/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.core;

/**
 * encapsulating the id of each document
 * @author Z. Pan
 * @version 1.0
 */

public class DocId implements java.io.Serializable{

  /**
   * Constructor
   */
  public DocId(String s) {
    id = new String(s);
    if(id.endsWith("#"))
      id = id.substring(0,id.length()-1);
  }

  /**
   * Get the id.
   */
  public String getId(){
    return id;
  }

  /**
   * Equals method.
   */
  public boolean equals(Object o){
    if(o instanceof DocId){
      if(((DocId)o).getId().equalsIgnoreCase(id)){
        return true;
      }
    }
    return false;
  }

  /**
   * HashCode method.
   */
  public int hashCode(){
    return id.hashCode();
  }

  private String id;
}