/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.core;
import java.util.Collection;
/**
 * Encapsulating the individuals and their related property values.
 * @author Z. Pan
 * @version 1.0
 */

public interface Individual extends OntObject{


  /**
   * Get the sourece classes.
   */
  public ObjectId[] getSourceClasses();

  /**
   * Add a source class.
   */
  public void addSourceClass(ObjectId cid);

  /**
   * Delete a source class.
   */
  public void deleteSourceClass(ObjectId cid);

  /**
   * Add a related property.
   */
  public void addProperty(ObjectId pid, ObjectId v);

  /**
   * Delete a related property.
   */
  public void deleteProperty(ObjectId pid, ObjectId v);

  /**
   * Get all the related properties.
   */
  public ObjectId[] getProperties();

  /**
   * Get all the values on specfied property.
   */
  public ObjectId[] getValuesForProperty(ObjectId pid);

  /**
   * Add a id which is same as this individual.
   */
  public void addSameAs(ObjectId id);

  /**
   * Delete a id which is same as this individual.
   */
  public void deleteSameAs(ObjectId id);

  /**
   * Get all the ids that are same as this individual.
   */
  public ObjectId[] getAllSameAs();

  /**
   * Get the set of same individuals which this individual belongs to.
   */
  public Collection getSameSet();

  /**
   * Set the set of same individuals which this individual belongs to.
   */
  public void setSameSet(Collection c);

  /**
   * Add a id which is differen from this individual.
   */
  public void addDifferentFrom(ObjectId id);

  /**
   * Delete a id which is differen from this individual.
   */
  public void deleteDifferentFrom(ObjectId id);

  /**
   * Get all the ids which are differen from this individual.
   */
  public ObjectId[] getAllDifferentFrom();

}
