/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.core;

/**
 * encapsulating the id of each ontObject
 * @author Z. Pan
 * @version 1.0
 */

public class ObjectId implements java.io.Serializable{

  /**
   * Constructor
   */
  public ObjectId(String s) {
    id = new String(s);
    int pind = -1;
    int sind = -1;
    pind = id.indexOf('#');
    sind = id.lastIndexOf('/');
    if(pind >0){
      nameSpace = id.substring(0,pind+1);
      localName = id.substring(pind+1,id.length());
    }
    else if(sind>0&&id.charAt(sind-1)!='/'){
      nameSpace = id.substring(0,sind+1);
      localName = id.substring(sind+1,id.length());
    }
    else if(s.startsWith("[")&&s.endsWith("]")){ //if it's a pseudo-id for anonymous objects.
      nameSpace = "";
      localName = "";
    }
    else{ //if the id is a full url without '#'. need further decisions.
      nameSpace = "";
      localName = id;
    }
  }

  /**
   * Get the id.
   */
  public String getId(){
    return id;
  }

  /**
   * Get the namespace.
   */
  public String getNameSpace(){
    return nameSpace;
  }

  /**
   * Set the namespace.
   */
  public void setNameSpace(String ns){
    nameSpace = ns;
    id = nameSpace+localName;
  }

  /**
   * Get the local name.
   */
  public String getLocalName(){
    return localName;
  }

  /**
   * Set the local name.
   */
  public void setLocalName(String ln){
    localName = ln;
    id = nameSpace+localName;
  }

  /**
   * Overide equals method.
   */
  public boolean equals(Object o){
    if(o instanceof ObjectId ){
      ObjectId oid = (ObjectId)o;

      /* change by Heflin 6/14/05 */
      // if(id.equals(oid.getId()))
      if(getId().equals(oid.getId()))
        return true;
    }
    return false;
  }

  /**
   * Overide hashCode method.
   */
  public int hashCode(){
    return id.hashCode();
  }

  private String id;
  private String nameSpace;
  private String localName;
}
