/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.core;

/**
 * Wrap the property restrictions in the ontology.
 * @author Z. Pan
 * @version 1.0
 */

public interface PropertyRestriction extends OntClass{

  public static final int INFINITY = -1;

  /**
   * Get the property restricted on.
   */
  public ObjectId getOnProperty();

  /**
   * Set the property restricted on.
   */
  public void setOnProperty(ObjectId p);

  /**
   * Get the specified restriction class of 'allValuesFrom'.
   */
  public ObjectId getAllValuesFrom();

  /**
   * Set the specified restriction class of 'allValuesFrom'.
   */
  public void setAllValuesFrom(ObjectId c);

  /**
   * Get the specified restriction class of 'someValuesFrom'.
   */
  public ObjectId getSomeValuesFrom();

  /**
   * Set the specified restriction class of 'someValuesFrom'.
   */
  public void setSomeValuesFrom(ObjectId c);

  /**
   * Get the specified number of 'minCardinality'.
   */
  public int getMinCardinality();

  /**
   * Set the specified number of 'minCardinality'.
   */
  public void setMinCardinality(int n);

  /**
   * Get the specified number of 'maxCardinality'.
   */
  public int getMaxCardinality();

  /**
   * Set the specified number of 'maxCardinality'.
   */
  public void setMaxCardinality(int n);

  /**
   * Get the specified value of 'hasValue'.
   */
  public ObjectId getHasValue();

  /**
   * Set the specified value of 'hasValue'.
   */
  public void setHasValue(ObjectId i);

}
