package edu.lehigh.swat.hawk.fol;


import java.io.Serializable;
import java.lang.Cloneable;


/**
 *
 * Wrapper for FOL Atom
 *
 *
 * @author zhp2
 *
 */


public class Atom implements Serializable, Cloneable{

    /**
     *
     * Constructs an Atom from a Literal
     *
     */
    private String predicate;
    private int var1;
    private int var2;
    private boolean binary;
    private boolean primitive;

    public Atom (String pred, int var){

        predicate = pred;
        var1 = var;
        var2 = -1;
        binary = false;
        primitive = true;

    }

    public Atom (String pred, int v1, int v2){

        predicate = pred;
        var1 = v1;
        var2 = v2;
        binary = true;
        primitive = true;

    }

    public Atom(String pred, int[] args){
        predicate = pred;
        var1 = args[0];
        var2 = args[1];
        if(args[1]<0)
            binary = false;
        else
            binary = true;
        primitive = true;
    }

    public void setPrimitive(boolean p){
        primitive = p;
    }

    public boolean isPrimitive(){
        return primitive;
    }

    public void setBinary(boolean b){
        binary = b;
    }

    public boolean isBinary(){
        return binary;
    }

    public String toString() {
        if(!binary)
            return predicate+"(x"+var1+")";
        else
            return predicate+"(x"+var1+", x"+var2+")";
    }

    public int getFirstArgument(){
        return var1;
    }

    public int getSecondArgument(){
        return var2;
    }

    public int[] getArguments () {
        return  new int[]{var1,var2};
    }

    public String getPredicate(){
        return predicate;

    }

    public boolean equals(Object o){
        Atom at  = (Atom)o;
        if(at.getPredicate().equals(this.getPredicate())
        &&at.getArguments()[0]==this.getArguments()[0]
        &&at.getArguments()[1]==this.getArguments()[1]
        )
            return true;
        else
            return false;
    }

    public int hashCode(){
        int hc = predicate.hashCode()+31*var1+17*var2;
//        System.out.println(predicate+" hashcode="+hc);
        return hc;
    }

}
