package edu.lehigh.swat.hawk.fol;

import java.util.*;
/**
 * <p>Title: </p>
 *
 * <p>Description: Wrapping FOL Horn rule</p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: Lehigh University</p>
 *
 * @author Z. Pan
 * @version 1.0
 */


public class HornRule implements java.io.Serializable{

    public static final int X = 1;
    public static final int Y = 2;
    public static final int Z = 3;

    private Atom head;
    private Vector<Atom> body;
    private int variable;

    public HornRule() {
        variable = 1;
        body = new Vector<Atom>();
    }

    public HornRule(Atom h, Vector b){
        variable = 1;
        head = h;
        body = b;
    }

    public Atom getHead(){
        return head;
    }

    public void setHead(Atom h){
        head = h;
    }

    public Vector<Atom> getBody(){
        return body;
    }

    public void addToBody(Atom at){
        body.add(at);
    }

    public void removeFromBody(Atom at){
        body.remove(at);
    }

    public int getNewVariable(){
        return ++variable;
    }

    public int getVariable(){
        return variable;
    }

    public String toString(){
        String s = "";
        for(Iterator<Atom> i = body.listIterator(); i.hasNext();){
            s = s+"^"+i.next().toString();
        }
        s = s+"-->"+head.toString();
        return s;
    }
}
