package edu.lehigh.swat.hawk.owl;

import java.util.Hashtable;

/** This class maintains a table of logical URIs and is used to populate as well as fetch the physical URIs 
 *  against their corresponding logical URIs
 * 
 * @author Ameet Chitnis
 *
 */



public class Proxy {
	
	private Hashtable<String, String> table;
	
	public Proxy(){
		table = new Hashtable<String, String>();
	}
	
	public void register(String ontUri, String phyUri){
		if(!table.containsKey(ontUri))
			table.put(ontUri, phyUri);
	}
	
	public void remove(String ontUri){
		if(table.containsKey(ontUri))
			table.remove(ontUri);
	}
	
	public String getURI(String ont){
		if(table.containsKey(ont))
			return table.get(ont);
		else
			return ont;
	}
	
}
