/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage.ontper.dldb;

import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.core.Document;
import java.sql.*;
import java.util.*;
import java.util.Map.Entry;
import edu.lehigh.swat.hawk.core.Axiom;
import edu.lehigh.swat.hawk.core.AxiomNode;
import edu.lehigh.swat.hawk.fol.*;

/**
 * <p>encapsulating the web ontology </p>
 * @author Z. Pan
 * @version 1.0
 */

public class Ontology extends edu.lehigh.swat.hawk.storage.dldb.Ontology{


/**
   * Constructor
   *
   */
  public Ontology(edu.lehigh.swat.hawk.storage.dlmemory.Ontology mOnto){
        super(mOnto);
//        this.memoryOnto = mOnto;
  }

  /**
   * add a class to this ontology
   */
  public void addOntClass(edu.lehigh.swat.hawk.core.OntClass c){
    memoryOnto.addOntClass(c);
    if(dbName==null)
        dbName = ((DldbStorage)getModel()).getDBName();
    if(compatibleOntos==null)
      this.getCompatiblePriorOnts();

    String tableName = model.getTableName(c.getID());
    String className = c.getID().getLocalName(); //add for persp
    if(tableName==null)
      return;
    String qs = "CREATE TABLE "+tableName
    +" (\nID INTEGER not null,\nSOURCE INTEGER not null,ONTO INTEGER,\nPRIMARY KEY(ID,SOURCE)\n)";

    try{
      stmt.executeUpdate(qs);
    }
     catch(SQLException e){
                System.out.println("error when store class");
                System.out.println(qs);
                System.out.println("SQLState:"+e.getSQLState());
                System.out.println("Message :"+e.getMessage());
                System.out.println("Vendor  :"+e.getErrorCode());

              }

      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_ext_view";

      qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
          +" WHERE ONTO="+ontSeq;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(className))
            qs2+=" UNION SELECT * FROM "+className+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }

        String qViewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
        String qs5 =  "CREATE VIEW "+qViewName+" AS\n SELECT * FROM "+viewName;

      String qs4= "Insert into tables_index values ('"+tableName+"', "+ontSeq+", "+memoryOnto.getClassIndex(c.getID())+")"; //zhp2: insert tables_index
      try{
        String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
        stmt.executeUpdate(qs4);
        stmt.executeUpdate(qs5);
      }
      catch(SQLException e){
        System.out.println("error when store class, create view");
        System.out.println(qs2);
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
  }



  /**
   * add a property to this ontology
   */
  public void addProperty(edu.lehigh.swat.hawk.core.OntProperty prop){
    memoryOnto.addProperty(prop);
    if(dbName==null)
        dbName = ((DldbStorage)getModel()).getDBName();
    if(compatibleOntos==null)
      this.getCompatiblePriorOnts();

    String tableName = model.getTableName(prop.getID());
    String propName = prop.getID().getLocalName();
    if(tableName==null)
      return;
    String qs = "";
//    String indexs = "";
//    String indexo = "";
    String pinfo = "INSERT INTO propertytypes VALUES('";
    tableName = tableName+"_p";
    if((prop.isDatatype()!=null && !prop.isDatatype().booleanValue())||
        prop.isFunctional()||prop.isTransitive()||prop.isInverseFunctional()||
         prop.isSymmetric()){
      qs = "CREATE TABLE "+tableName
    +" ( SUBJECT INTEGER not null, OBJECT INTEGER not null, SOURCE INTEGER not null, ONTO INTEGER,"+
    " PRIMARY KEY(SUBJECT,OBJECT,SOURCE), index(object))";
      pinfo += tableName+"', 'object')";
      if(dbName.indexOf("jdbc:db2")>0){
          qs = "CREATE TABLE "+tableName
        +" ( SUBJECT INTEGER not null, OBJECT INTEGER not null, SOURCE INTEGER not null, ONTO INTEGER,"+
    " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
      }
    }
    else{
      ObjectId range = prop.getRange();
      if(range!=null&&range.getNameSpace().equalsIgnoreCase("http://www.w3.org/2001/XMLSchema#")){
          if(range.getLocalName().toLowerCase().endsWith("integer")){
              qs = "CREATE TABLE "+tableName
                   +" ( SUBJECT INTEGER, OBJECT INTEGER,"+
                   " SOURCE INTEGER, ONTO INTEGER,"+
                   " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
              pinfo += tableName+"', 'int')";
          }
          else if(range.getLocalName().toLowerCase().endsWith("float")){
              qs = "CREATE TABLE "+tableName
                   +" (SUBJECT INTEGER not null, OBJECT FLOAT not null,"+
                   " SOURCE INTEGER not null, ONTO INTEGER,"+
                   " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
              pinfo += tableName+"', 'float')";
          }
          else if(range.getLocalName().toLowerCase().endsWith("date")){ // Ameet Aug 30, 2007
                        qs = "CREATE TABLE "+tableName
                             +" (SUBJECT INTEGER not null, OBJECT DATE not null,"+
                             " SOURCE INTEGER not null, ONTO INTEGER,"+
                             " PRIMARY KEY(SUBJECT,OBJECT,SOURCE))";
                        pinfo += tableName+"', 'date')";
          }
      }
      if(qs.length()<1){
          if(dbName.indexOf(".mdb")>0)
              qs = "CREATE TABLE " + tableName
               + " (SUBJECT INTEGER, OBJECT MEMO,"
               +" SOURCE INTEGER,ONTO INTEGER," +
               " INDEX(SUBJECT, OBJECT))";
      else if(dbName.indexOf("jdbc:db2")>0){
          qs = "CREATE TABLE " + tableName
            + " (SUBJECT INTEGER not null, OBJECT CLOB(4096),"
            +" SOURCE INTEGER not null, ONTO INTEGER," +
            " unique (SUBJECT))";
      }
          else
             qs = "CREATE TABLE " + tableName
               + " (SUBJECT INTEGER not null, OBJECT TEXT not null,"
               +" SOURCE INTEGER not null, ONTO INTEGER," +
               " INDEX (SUBJECT), INDEX(OBJECT(15)))";
           //"INDEX (SUBJECT), FULLTEXT INDEX (OBJECT))";
          pinfo += tableName + "', 'datatype')";
      }
    }

   // log.println(qs);

    try{
      stmt.executeUpdate(qs);
      stmt.executeUpdate(pinfo);
    }
    catch(SQLException e){
                //log.println("error when store property");
                System.out.println(qs);
      System.out.println("error when store property");
      System.out.println("SQLState:"+e.getSQLState());
      System.out.println("Message :"+e.getMessage());
      System.out.println("Vendor  :"+e.getErrorCode());
    }

      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
  //    if(viewSeqNum == currentSeqNum){

        qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
            +" WHERE ONTO="+ontSeq;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(propName))
            qs2+=" UNION SELECT * FROM "+propName+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }



      String qs3 = "";
      String qs4= "Insert into tables_index values ('"+tableName+"', "+ontSeq+", "+memoryOnto.getPropertyIndex(prop.getID())+")"; //zhp2: insert tables_index
      try{
        qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
        stmt.executeUpdate(qs4);
      }

      catch(SQLException e){
              //  log.println("error when store class, create view");
        System.out.println(qs2);
        System.out.println("error when store class, create view");
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
  }

  /**
   * Flush the axioms into database.
   */
  public void flush(){
      flushImports();
      super.flush();

/*
      DocId[] dids = model.getImportsClosure(this);  //zhp2 on 11/24/08
      edu.lehigh.swat.hawk.core.Ontology[] imports = null;
      if(dids!=null){
        int len = dids.length;
        imports = new edu.lehigh.swat.hawk.core.Ontology[len];
        for(int i=0;i<len;i++){
          DocId did = dids[i];
          edu.lehigh.swat.hawk.core.Ontology iont = (edu.lehigh.swat.hawk.core.Ontology)model.getDocument(did.getId());
          imports[i] = iont;
        }
      }
      ((edu.lehigh.swat.hawk.storage.dlmemory.Ontology) memoryOnto)
        .computeSubsumptions(((DldbStorage)this.getModel()).getReasonerUrl(),imports);



      memoryOnto.convertAxiomsToRules();
      memoryOnto.expandRules();

      flushImports();

      flushSubs();

      flushEquivals();

      flushInverseOf();

      flushCyclicRules();

      try{
          if (getAllProperties().length > 0) {
              model.updatePropertyTypes(); //zhop2: every time add a new ontology, update the property types info.
          }
          model.storeOntology(this);
      }catch(Exception e){
          System.out.println(e.getMessage());
          e.printStackTrace();
      }


/*
    DocId[] dids = memoryOnto.getImports();
    edu.lehigh.swat.hawk.core.Ontology[] imports = null;
    if(dids!=null){
      int len = dids.length;
      imports = new edu.lehigh.swat.hawk.core.Ontology[len];
      for(int i=0;i<len;i++){
        DocId did = dids[i];
        Document doc = model.getDocument(did.getId());
        if(doc instanceof edu.lehigh.swat.hawk.core.Ontology){
          edu.lehigh.swat.hawk.core.Ontology iont = (edu.lehigh.swat.hawk.core.
              Ontology) doc;
          imports[i] = iont;
        }
      }
    }
    ((edu.lehigh.swat.hawk.storage.dlmemory.Ontology) memoryOnto)
        .computeSubsumptions(((DldbStorage)this.getModel()).getReasonerUrl(),imports);

    dbName = ((DldbStorage)getModel()).getDBName();
    flushImports();  //added by z.pan
    flushSubs();
    flushEquivals();
    flushInverseOf();
    if(getAllProperties().length>0){
        model.updatePropertyTypes();  //zhop2: every time add a new ontology, update the property types info.
    }
    model.storeOntology(this);
*/
  }

  private String getNodeView(AxiomNode node){
      int type = node.getJoinType();
      if(type==edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE){
              String tname = model.getTableName(node.getAtomicNode());
              if(tname==null)
                  return null;
              String vname = tname + "_" + String.valueOf(ontSeq) + "_view";
              return "SELECT * FROM " + vname;
      }
      else if (type==edu.lehigh.swat.hawk.core.Ontology.SOMEVALUERESTRICTION) {
              String pvname = model.getTableName(node.getOnProperty().getAtomicNode())+"_p_"+String.valueOf(ontSeq) + "_view";
              String cvname = getNodeView(node.getSomeValuesFrom()).substring(14);
              return "SELECT subject AS ID, "+pvname+".source, "+pvname+".onto FROM "
                      + pvname +", "+cvname
                      +" where " + pvname + ".object = "+cvname+".ID";
              //zhp2: MySQL doesn't support subquery in from clause of view definition. Thus the class has to be atomic.
      }
      else if(type==edu.lehigh.swat.hawk.core.Ontology.INTERSECTIONOF){
          String view = "";
          List<AxiomNode> list = node.getChildren();
          Iterator<AxiomNode> it = list.iterator();
          while(it.hasNext()){
              AxiomNode child = it.next();
              if(view.length()<1)
                  view = getNodeView(child);
              else{
                  if(child.getAtomicNode()!=null)
                      view = view + " WHERE ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                  else{
                      String temp = getNodeView(child);
                      int start = temp.indexOf(" AS ID");
                      int end = temp.indexOf(" FROM");
                      String ins = temp.substring(0,start+6)+temp.substring(end);
                      view = view + " WHERE ID IN ( "+ ins + ")";
                  }

              }
          }
          return view;
      }
      return "";
  }

  private String getNodeView(AxiomNode node, ObjectId rightHand, boolean isProperty){
      int type = node.getJoinType();
      if(type==edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE){
              String tname = model.getTableName(node.getAtomicNode());
              if(tname==null)
                  return null;
              if(isProperty)
                  tname = tname + "_p";
              return "SELECT * FROM " + tname;
      }
      else if (type==edu.lehigh.swat.hawk.core.Ontology.SOMEVALUERESTRICTION) {
              String pvname = model.getTableName(node.getOnProperty().getAtomicNode())+"_p_"+String.valueOf(ontSeq) + "_view";
              String cvname = getNodeView(node.getSomeValuesFrom()).substring(14);
              return "SELECT subject AS ID, "+pvname+".source, "+pvname+".onto FROM "
                      + pvname +", "+cvname
                      +" where " + pvname + ".object = "+cvname+".ID";
              //zhp2: MySQL doesn't support subquery in from clause of view definition. Thus the class has to be atomic.
      }
      else if(type==edu.lehigh.swat.hawk.core.Ontology.INTERSECTIONOF){
          String view = "";
          List<AxiomNode> list = node.getChildren();
          Iterator<AxiomNode> it = list.iterator();
          boolean lastIsQuery = false;
          while(it.hasNext()){
              AxiomNode child = it.next();
              if(child.getAtomicNode()!=null&&((edu.lehigh.swat.hawk.storage.simplememory.OntClass)getOntClass(child.getAtomicNode())).subsumes(rightHand))
                  continue;
              if(view.length()<1){
                  view = getNodeView(child);
                  lastIsQuery = true;
              }
              else{
                  if(child.getAtomicNode()!=null){
                      if(lastIsQuery)
                          view = view + " and ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                      else
                          view = view + " WHERE ID IN (select id from "+ getNodeView(child).substring(14) + ")";
                  }
                  else{
                      String temp = getNodeView(child);
                      int start = temp.indexOf(" AS ID");
                      int end = temp.indexOf(" FROM");
                      String ins = temp.substring(0,start+6)+temp.substring(end);
                      view = view + " WHERE ID IN ( "+ ins + ")";
                  }
              }
          }
          return view;
      }
      return "";
  }

  protected void flushSubs(){
      Set set = memoryOnto.getExpandedAtoms().entrySet();
      Iterator<Entry> it = set.iterator();
      while(it.hasNext()){
          Entry<String, Vector<Vector<Atom>>> en = it.next();
          String pred = en.getKey();
          Atom a = new Atom(pred, HornRule.X);
          Vector<Vector<Atom>> DNF = en.getValue();
          updateView(a, DNF);
      }

    //deal with subClass
/*
    List<Axiom> subaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBCLASSOF);
    if(subaxioms!=null){
        Iterator<Axiom> it = subaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();
            String leftView = getNodeView(left);
            String className = model.getTableName(right.getAtomicNode());
            if (className == null || leftView==null)
                continue;
            String vName = className + "_" + String.valueOf(ontSeq) + "_view";
            StringBuffer cvb;

            String def = model.getViewDefinition(vName);
            if (def == null) {
                System.out.println("view definition not found:" + vName);
                continue;
            } else
                cvb = new StringBuffer(def);
            if (leftView == null)
                continue;
            cvb.append(" UNION " + leftView);
            model.setViewDefinition(vName, cvb.toString());
        }
    }
*/
    //deal with subProperty
   List<Axiom> subpaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBPROPERTYOF);
   if(subpaxioms!=null){
       Iterator<Axiom> itp = subpaxioms.iterator();
       while (itp.hasNext()) {
           Axiom axiom = itp.next();
           AxiomNode left = axiom.getLeftAxiomNode();
           AxiomNode right = axiom.getRightAxiomNode();
           String leftp = model.getTableName(left.getAtomicNode());
           String rightp = model.getTableName(right.getAtomicNode());
           if (leftp == null || rightp == null)
               continue;
           String leftView = "SELECT * FROM " + leftp + "_p_" +
                             String.valueOf(ontSeq) + "_view";
           String vName = rightp + "_p_" + String.valueOf(ontSeq) + "_view";
           StringBuffer cvb;

           String def = model.getViewDefinition(vName);
           if (def == null) {
               System.out.println("view definition not found:" + vName);
               continue;
           } else
               cvb = new StringBuffer(def);
           if (leftView == null)
               continue;
           cvb.append(" UNION ALL " + leftView);
           model.setViewDefinition(vName, cvb.toString());
       }
   }
  }

  /**
   * The logic here is that subsumptions inherited from equivalencies should
   * have already been taken care of by the DL reasoner.
   * Note, currently the code can't handle if one of the node is of complex class type.
   */
  protected void flushEquivals(){
    //deal with equivalentClass
/*
    List<Axiom> subaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.EQUIVALENTCLASS);
    if(subaxioms!=null){
        Iterator<Axiom> it = subaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();

            if (left.getJoinType() ==
                edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                right.getJoinType() ==
                edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE) {
                String lClassName = model.getTableName(left.getAtomicNode());
                String lViewName = lClassName + "_" + String.valueOf(ontSeq) +
                                   "_view";
                String lDef = model.getViewDefinition(lViewName);

                String rClassName = model.getTableName(right.getAtomicNode());
                String rViewName = rClassName + "_" + String.valueOf(ontSeq) +
                                   "_view";
                String rDef = model.getViewDefinition(rViewName);
                if (lDef == null) {
                    System.out.println("view definition not found:" + lViewName);
                } else if (rDef == null) {
                    System.out.println("view definition not found:" + rViewName);
                } else {
                    StringBuffer lvb = new StringBuffer(lDef);
                    StringBuffer rvb = new StringBuffer(rDef);

                    if (rvb.indexOf(" UNION") > 1)
                        lvb.append(" UNION " +
                                   rvb.substring(rvb.indexOf(" AS")+3, rvb.indexOf(" UNION")));
                    else
                        lvb.append(" UNION " + rvb.substring(rvb.indexOf(" AS")+3));
                    model.setViewDefinition(lViewName, lvb.toString());

                    if (lvb.indexOf(" UNION") > 1)
                        rvb.append(" UNION " +
                                   lvb.substring(lvb.indexOf(" AS")+3, lvb.indexOf(" UNION")));
                    else
                        rvb.append(" UNION " + lvb.substring(lvb.indexOf(" AS")+3));
                    model.setViewDefinition(rViewName, rvb.toString());
                }
            }
        }
    }
*/
   //deal with equivalentProperty
    List<Axiom> equipaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.EQUIVALENTPROPERTY);
    if(equipaxioms!=null){
        Iterator<Axiom> it = equipaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();

            if (left.getJoinType() ==
                edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE &&
                right.getJoinType() ==
                edu.lehigh.swat.hawk.core.Ontology.ATOMICNODE) {
                String lClassName = model.getTableName(left.getAtomicNode());
                String lViewName = lClassName +"_p"+ "_" + String.valueOf(ontSeq) +
                                   "_view";
                String lDef = model.getViewDefinition(lViewName);

                String rClassName = model.getTableName(right.getAtomicNode());
                String rViewName = rClassName +"_p"+ "_" + String.valueOf(ontSeq) +
                                   "_view";
                String rDef = model.getViewDefinition(rViewName);
                if (lDef == null) {
                    System.out.println("view definition not found:" + lViewName);
                } else if (rDef == null) {
                    System.out.println("view definition not found:" + rViewName);
                } else {
                    StringBuffer lvb = new StringBuffer(lDef);
                    StringBuffer rvb = new StringBuffer(rDef);

                    if (rDef.indexOf(" UNION") > 1)
                        lvb.append(" UNION ALL ").
                                   append(rDef.substring(rDef.indexOf(" AS")+4,rDef.indexOf(" UNION")));
                    else
                        lvb.append(rDef.substring(rDef.indexOf(" AS")+4));
                    model.setViewDefinition(lViewName, lvb.toString());

                    if (lDef.indexOf(" UNION") > 1)
                        rvb.append(" UNION ALL ").
                                   append(lDef.substring(lDef.indexOf(" AS")+4,lDef.indexOf(" UNION")));
                    else
                        rvb.append(lDef.substring(lDef.indexOf(" AS")+4));

                    model.setViewDefinition(rViewName, rvb.toString());
                }
            }
        }
    }

    Hashtable<String,String> viewDefs = model.getUpdatedViewDefs();
    Enumeration enu = viewDefs.keys();
    while(enu.hasMoreElements()){
        String vName = (String)enu.nextElement();
        String def = (String)viewDefs.get(vName);
        StringBuffer cvb = new StringBuffer(def);
        try {
            if (dbName.indexOf("mysql") > 0)
                stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
            else{
                String dv = "drop view "+vName;
                stmt.execute(dv);
                stmt.execute(def);
            }
            String qs3 = "UPDATE view_definition SET definition='" + def + "'" +
                         "WHERE viewname='" + vName + "'";
            stmt.execute(qs3);
        } catch (SQLException e) {
            System.out.println("error when recreate property hierarchy");
            System.out.println(def);
            System.out.println("SQLState:" + e.getSQLState());
            System.out.println("Message :" + e.getMessage());
            System.out.println("Vendor  :" + e.getErrorCode());
        }
    }
    if(dbName.indexOf("jdbc:db2")>0){
        enu = viewDefs.keys();
        System.out.println("enumer 2nd pass");
        while(enu.hasMoreElements()){
            String vName = (String)enu.nextElement();
//            System.out.println("once more: "+vName);
            String def = (String)viewDefs.get(vName);
           // StringBuffer cvb = new StringBuffer(def);
            try {
                    stmt.execute(def);
            } catch (SQLException e) {
                if(!e.getSQLState().equals("42710")){
                    System.out.println(
                            "error when recreate class hierarchy, 2nd pass for db2");
                    System.out.println(def);
                    System.out.println("SQLState:" + e.getSQLState());
                    System.out.println("Message :" + e.getMessage());
                    System.out.println("Vendor  :" + e.getErrorCode());
                }
            }
       }
       enu = viewDefs.keys();
       System.out.println("enumer 3rd pass");
       while(enu.hasMoreElements()){
           String vName = (String)enu.nextElement();
 //          System.out.println("twicw more: "+vName);
           String def = (String)viewDefs.get(vName);
          // StringBuffer cvb = new StringBuffer(def);
           try {
                   stmt.execute(def);
           } catch (SQLException e) {
               if(!e.getSQLState().equals("42710")){
                   System.out.println(
                           "error when recreate class hierarchy, 3rd pass for db2");
                   System.out.println(def);
                   System.out.println("SQLState:" + e.getSQLState());
                   System.out.println("Message :" + e.getMessage());
                   System.out.println("Vendor  :" + e.getErrorCode());
               }
           }
       }
   }

   model.clearViewDefinitions();

  }

  /**
   * Flush owl:inverseOf into db view.
   */
  protected void flushInverseOf(){
    edu.lehigh.swat.hawk.core.OntProperty[] Properties
        = this.getAllPlusImportedProperties();
    int pNum = Properties.length;

    for (int i = 0; i < pNum; i++) {
      edu.lehigh.swat.hawk.core.OntProperty prop = Properties[i];
      if (prop.getID().getLocalName() == null || prop.getID().getLocalName() == "")
        continue;

      String propertyName = model.getTableName(prop.getID())+"_p";
  //  int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      String vName = propertyName  +"_"+String.valueOf(ontSeq)+ "_view";

 //     String invName = propertyName  +"_"+String.valueOf(ontSeq)+ "_inv"+ "_view";

      if(prop.isSymmetric()&&!prop.isTransitive()){
          String cv = "CREATE or REPLACE VIEW " + vName + " AS SELECT * FROM " +
                      propertyName+" UNION SELECT "+
                      propertyName + ".OBJECT AS SUBJECT, " + propertyName
                      + ".SUBJECT AS OBJECT, " + propertyName + ".source, " +
                      propertyName + ".onto " + "FROM " + propertyName;
          try {
              stmt.execute(cv);
              String qs3 = "UPDATE view_definition SET definition='" + cv + "'" +
                           "WHERE viewname='" + vName + "'";
              stmt.execute(qs3);
          //    String qs4 = "UPDATE propertytypes SET type='hasinverse_" + ontSeq +
         //                   "' WHERE pname='" + propertyName + "'";
        //      stmt.execute(qs4);
          } catch (SQLException e) {
              System.out.println("error when doing symmetric property hierarchy");
              System.out.println(cv);
              System.out.println("SQLState:" + e.getSQLState());
              System.out.println("Message :" + e.getMessage());
              System.out.println("Vendor  :" + e.getErrorCode());
          }
      }
    }

    List<Axiom> invaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.INVERSEOF);
    if(invaxioms!=null){
        Iterator<Axiom> it = invaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();

            ObjectId lpid = left.getAtomicNode();
            ObjectId rpid = right.getAtomicNode();

            if (left.getJoinType()==Ontology.INVERSEOF){
                lpid = left.getChildren().get(0).getAtomicNode();
            }

            if (right.getJoinType()==Ontology.INVERSEOF){
                rpid = right.getChildren().get(0).getAtomicNode();
            }

            if(lpid==null||rpid==null)
                continue;

            String lpName = model.getTableName(lpid)+"_p";
            String rpName = model.getTableName(rpid)+"_p";

            String lvName = lpName  +"_"+String.valueOf(ontSeq)+ "_view";
            String linvName = lpName  +"_"+String.valueOf(ontSeq)+ "_inv"+ "_view";

            StringBuffer cvb = null;
            String cbkp = null;
            String def = model.getViewDefinition(lvName);
            if(def==null)
                    continue;
            String bkpDef = model.getViewDefinition(lvName+"_bkp");
            if (bkpDef == null){
                cvb = new StringBuffer(def);
                int ind = cvb.indexOf(lvName);
                int iind = ind + lvName.length();
                cvb.insert(iind, "_bkp");
                cbkp = cvb.toString();
            }else
                cbkp = "";

            String cinv = "create or replace view " + linvName +
                    " as select object, subject, source, onto FROM " +
                          lvName + "_bkp";

            try {
               if(cbkp.length()>1){
                   stmt.executeUpdate(cbkp);
                   String qs3 = "INSERT INTO view_definition VALUES ('"+lvName+"_bkp', '"+cbkp+"')";
                   stmt.executeUpdate(qs3);
               }
               stmt.execute(cinv);
           } catch (SQLException e) {
               System.out.println("error when doing inverse property");
               System.out.println(cinv);
               System.out.println("SQLState:" + e.getSQLState());
               System.out.println("Message :" + e.getMessage());
               System.out.println("Vendor  :" + e.getErrorCode());
           }


            String rvName = rpName  +"_"+String.valueOf(ontSeq)+ "_view";
            String rinvName = rpName  +"_"+String.valueOf(ontSeq)+ "_inv"+ "_view";
            StringBuffer rcvb = null;
            String rcbkp = null;
            String rdef = model.getViewDefinition(rvName);
            if(rdef==null)
                    continue;
            String rbkpDef = model.getViewDefinition(rvName+"_bkp");
            if (rbkpDef == null){
                rcvb = new StringBuffer(rdef);
                int ind = rcvb.indexOf(rvName);
                int iind = ind + rvName.length();
                rcvb.insert(iind, "_bkp");
                rcbkp = rcvb.toString();
            }else
                rcbkp = "";

            String rcinv = "create or replace view " + rinvName +
                    " as select object, subject, source, onto FROM " +
                          rvName + "_bkp";


            try {
                if(rcbkp.length()>1){
                    stmt.executeUpdate(rcbkp);
                    String qs3 = "INSERT INTO view_definition VALUES ('"+rvName+"_bkp', '"+rcbkp+"')";
                    stmt.executeUpdate(qs3);
                }
                stmt.execute(rcinv);
            } catch (SQLException e) {
                System.out.println("error when doing inverse property");
                System.out.println(rcinv);
                System.out.println("SQLState:" + e.getSQLState());
                System.out.println("Message :" + e.getMessage());
                System.out.println("Vendor  :" + e.getErrorCode());
            }

            cvb = new StringBuffer(def);
            cvb.append(" UNION SELECT * FROM ").append(rinvName);

            rcvb = new StringBuffer(rdef);
            rcvb.append(" UNION SELECT * FROM ").append(linvName);

            try{
                stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
                stmt.execute(rcvb.insert(7, "OR REPLACE ").toString());
            }catch (SQLException e) {
                System.out.println("error when doing inverse property");
                System.out.println(cvb.toString());
                System.out.println("SQLState:" + e.getSQLState());
                System.out.println("Message :" + e.getMessage());
                System.out.println("Vendor  :" + e.getErrorCode());
            }
        }
    }
  }

  /**
   * Flush the imported classes and properties.
   */
  private void flushImports(){
    DocId[] dids = memoryOnto.getImports();
    if(dids==null)
      return;

    HashSet loadedClasses = new HashSet();
    HashSet loadedProperties = new HashSet();
    int len = dids.length;
    for(int i=0;i<len;i++){
      DocId did = dids[i];
      Document doc = (Document)model.getDocument(did.getId());
      if(!(doc instanceof edu.lehigh.swat.hawk.core.Ontology))
        continue;
      edu.lehigh.swat.hawk.core.Ontology ionto = (edu.lehigh.swat.hawk.core.Ontology)doc;
      //start added by zhp2 on 07/06/09
      List al = ionto.getAllAxioms();
      System.out.println("import axiom from "+ionto.getID().getId()+":"+al.size());
      if(al!=null&&al.size()>0){
          for (Iterator<Axiom> ai = al.iterator(); ai.hasNext(); ) {
              Axiom a = ai.next();
              this.addAxiom(a);
              this.addAxiomByType(a.getType(),a);
          }
      }
      System.out.println("now have subc "+this.getAxiomByType(Ontology.SUBCLASSOF).size());
      //end zhp2
      int iseq = model.getOntSeq(did.getId());
      edu.lehigh.swat.hawk.core.OntClass[] iclss = ionto.getAllPlusImportedClasses();
      int clen = iclss.length;
      for(int j=0;j<clen;j++){
        edu.lehigh.swat.hawk.core.OntClass icls = iclss[j];
        ObjectId cid = icls.getID();
        String tableName = model.getTableName(cid);
        if(tableName==null)
          continue;
        if(loadedClasses.contains(tableName))
            continue;
        loadedClasses.add(tableName);
        String viewName = tableName+"_"+ontSeq+"_ext_view";

        String ivName = tableName+"_"+iseq+"_ext_view";
        String vdef = model.getViewDefinition(ivName);
        if(vdef==null){
         System.out.println("ivname null:" + ivName);
         continue;
       }
        int start = vdef.indexOf(" WHERE ");
        int end = vdef.indexOf(" UNION");
        if(end<1)
            end = vdef.length();
        String oldWhere = vdef.substring(start, end);
        String newOnto = " or onto ="+ontSeq;

        String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName+ oldWhere + newOnto;

        String qViewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
        String qs5 =  "CREATE VIEW "+qViewName+" AS\n SELECT * FROM "+viewName;

        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.execute(qs2);
      //    System.out.println(qs2);
          stmt.execute(qs3);
          stmt.execute(qs5);
        }
        catch(SQLException e){
        //  log.println("error when store class, create view");
          System.out.println(qs2);
          System.out.println("error when store imported class, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());

        }
      }
      edu.lehigh.swat.hawk.core.OntProperty[] iprops = ionto.getAllPlusImportedProperties();
      int plen = iprops.length;
      for(int j=0;j<plen;j++){
        edu.lehigh.swat.hawk.core.OntProperty iprop = iprops[j];
        ObjectId pid = iprop.getID();
        String tableName = model.getTableName(pid);
        if(tableName==null)
          continue;
        if(loadedProperties.contains(tableName))
          continue;
        loadedProperties.add(tableName);
        tableName = tableName+"_p";
        String viewName = tableName+"_"+ontSeq+"_view";
        String ivName = tableName+"_"+iseq+"_view";
       // String ptype = (String)model.getPropertyTypes().get(tableName+"_p");
       // if(ptype!=null&&ptype.equals("hasinverse"))
       //         ivName = tableName+"_"+"p_inv_"+iseq+"_view";;

       String vdef = model.getViewDefinition(ivName);
       if(vdef==null){
        System.out.println("ivname:" + ivName);
        continue;
      }

      int start = vdef.indexOf(" WHERE ");
      int end = vdef.indexOf(" UNION");
      if(end<1)
          end = vdef.length();
       String oldWhere = vdef.substring(start, end);
       String newOnto = " or onto ="+ontSeq;

       String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName+ oldWhere + newOnto;

        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.execute(qs2);
       //   System.out.println(qs2);
          stmt.execute(qs3);
        }
        catch(SQLException e){
          System.out.println(qs2);
          System.out.println("error when store imported property, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());
        }
      }
    }
  }

/*
  private void flushIntersections(){
    //deal with equivalentClass
    edu.lehigh.swat.hawk.core.OntClass[] classes = this.getAllClasses();
    int cNum = classes.length;
    for(int i=0;i<cNum;i++){
      edu.lehigh.swat.hawk.core.OntClass cls = classes[i];
      if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
        continue;
      ObjectId[] eid = cls.getIntersectionOfs();
      String className = model.getTableName(cls.getID());
    //  int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      if(eid==null)
        continue;
      int sn = eid.length;
      if(sn<=0)
        continue;
      StringBuffer cvb = new StringBuffer("UNION ALL (SELECT * from ");

      for(int j=0;j<sn;j++){

        String tName = model.getTableName(eid[j]);
        String ivName = tName;
        if(tName != null){
            ivName = tName + "_view";
        }
        else{
            String[] ret = this.ViewForRestriction(eid[j]);
            if(ret==null){
                cvb=null;
                break;
            }

            ivName = ret[0];
            cvb.append(ret[1]);
        }
        if(ivName == null)
          continue;
        if(j==0){
            if(ivName.startsWith("(SELECT"))
                cvb.append(ivName.substring(1)).deleteCharAt(cvb.length()).append(" where ID IN ()");
            else
                cvb.append("SELECT * FROM ").append(ivName + " where ID IN ()");
        }
        else{
            int fromind = ivName.indexOf(" FROM ");
            int commaind = ivName.indexOf(",");
            if(fromind<=0)
                cvb.insert(cvb.length() - j,
                       "SELECT ID FROM " + ivName + " AND ID IN()");
            else
                cvb.insert(cvb.length()-j,
                ivName.substring(1,commaind)+ivName.substring(fromind)+" AND ID IN()");
        }
      }
      if(cvb==null)
          continue;
      cvb.delete(cvb.length()-13, cvb.length()-1);

      try{
        String cv = cvb.toString();
        if(dbName.endsWith(".mdb")|| dbName.indexOf("h2")>0){
            if(start!=null)
                stmt.execute(dv);
         stmt.execute(cv);
       }else if(dbName.indexOf("sql")>0){
//           stmt.execute(cvb.insert(7, "OR REPLACE ").toString());
           String cp = cpb.toString();
           stmt.execute(cp);
       }
        String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
            "WHERE viewname='"+vName+"'";
        stmt.execute(qs3);

      }
      catch(SQLException e){
        System.out.println("error when flush intersections");
        System.out.println(cvb.toString());
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
    }
  }
*/

/*
public void convertAxiomsToRules(){
    rawRules = new Hashtable();
    List<Axiom> subaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBCLASSOF);
    if(subaxioms!=null){
        Iterator<Axiom> it = subaxioms.iterator();
        while (it.hasNext()) {
            Axiom axiom = it.next();
            AxiomNode left = axiom.getLeftAxiomNode();
            AxiomNode right = axiom.getRightAxiomNode();
            if(left.getJoinType()!=Ontology.ATOMICNODE&&right.getJoinType()==Ontology.INTERSECTIONOF){
                //split RHS
            }
            // if left is union, right is atomic, split LHS
            if(right.getJoinType()==Ontology.ATOMICNODE){
                ObjectId rid = right.getAtomicNode();
                if(rid.getNameSpace().equals(""))
                    continue;
                HornRule rule = new HornRule();
                Atom head = new Atom(rid.getId(), rule.getVariable());
                rule.setHead(head);
                if(!nodeToAtoms(left, rule))
                    continue;
                System.out.println(rule.toString());
                if(rawRules.get(head.getPredicate())==null){
                    Vector<HornRule> commonHeadRules = new Vector<HornRule>();
                    commonHeadRules.add(rule);
                    rawRules.put(head.getPredicate(), commonHeadRules);
                }else{
                    Vector<HornRule> commonHeadRules = rawRules.get(head.getPredicate());
                    commonHeadRules.add(rule);
                    rawRules.put(head.getPredicate(), commonHeadRules);
                }
            }
        }
      }

      //properties. Maybe the views work, so FOL is not necessary.
      List<Axiom> subpaxioms = this.getAllAxiomsByType().get(edu.lehigh.swat.hawk.core.Ontology.SUBPROPERTYOF);
      if(subaxioms!=null){
          Iterator<Axiom> it = subaxioms.iterator();
          while (it.hasNext()) {
              Axiom axiom = it.next();
              AxiomNode left = axiom.getLeftAxiomNode();
              AxiomNode right = axiom.getRightAxiomNode();
          }
      }
  }

  protected boolean nodeToAtoms(AxiomNode node, HornRule rule){
      switch(node.getJoinType()){

      case Ontology.ATOMICNODE:
          Atom b = new Atom(node.getAtomicNode().getId(), rule.getVariable());
          rule.addToBody(b);
          break;

      case Ontology.INTERSECTIONOF:
          Vector<AxiomNode> children = node.getChildren();
          Iterator<AxiomNode> it = children.iterator();
          while (it.hasNext()) {
              AxiomNode child = it.next();
              nodeToAtoms(child, rule);
          }
          break;

      case Ontology.SOMEVALUERESTRICTION:
          AxiomNode property = node.getOnProperty();
          if (property.getJoinType() == Ontology.ATOMICNODE) {
              Atom a = new Atom(property.getAtomicNode().getId(),
                                rule.getVariable(), rule.getNewVariable());
              rule.addToBody(a);
          } else {
              //inverse property
          }
          AxiomNode restr = node.getSomeValuesFrom();
          nodeToAtoms(restr, rule);
          break;

      default:
         return false;
      }

      return true;
  }

  public void expandRules(){
      expandedAtoms = new Hashtable<String, Vector<Vector<Atom>>>();
      cyclicRules = new Hashtable<String, Vector<Vector<Atom>>>();
      inPlay = new Vector<String>();
      Enumeration enu = rawRules.keys();
      while (enu.hasMoreElements()) {
          String pred = (String) enu.nextElement();
          Atom p = new Atom(pred, HornRule.X);
          Vector<Vector<Atom>> cycleDisj = new Vector<Vector<Atom>>();
          Vector<Vector<Atom>> DNF = expandAtom(p);
          Iterator<Vector<Atom>> dit = DNF.iterator();
          while (dit.hasNext()) {
              Vector<Atom> conj = dit.next();
              Iterator<Atom> cit = conj.iterator();
              while (cit.hasNext()) {
                  Atom atom = cit.next();
                  if (atom.getPredicate().equals(p.getPredicate())
                      &&(atom.getArguments()[0] != p.getArguments()[0] ||
                       atom.getArguments()[1] != p.getArguments()[1])) {
                      cycleDisj.add(conj);
                  }
              }
          }
          if (!cycleDisj.isEmpty()) {
              cyclicRules.put(pred, cycleDisj);
              DNF.removeAll(cycleDisj);
              System.out.println("---Cyclic axioms found for " +
                                 pred);
          }
      }
  }

  protected Vector<Vector<Atom>> expandAtom(Atom a){
      if(expandedAtoms.get(a.getPredicate())!=null){
           Vector<Vector<Atom>> nochange = expandedAtoms.get(a.getPredicate());
           Vector<Vector<Atom>> temp = new Vector<Vector<Atom>>();
           int diff = a.getFirstArgument()-HornRule.X;
           for(Iterator<Vector<Atom>> i = nochange.iterator();i.hasNext();){
               Vector<Atom> nochangev = i.next();
               Vector<Atom> tempv = new Vector<Atom>();
               for(Iterator<Atom> j = nochangev.iterator(); j.hasNext(); ){
                   Atom nochangea = j.next();
                   Atom tempa;
                   if(nochangea.isBinary())
                       tempa = new Atom(nochangea.getPredicate(),nochangea.getFirstArgument()+diff,nochangea.getSecondArgument()+diff);
                   else
                       tempa =  new Atom(nochangea.getPredicate(),nochangea.getFirstArgument()+diff);
                   tempv.add(tempa);
               }
               temp.add(tempv);
            }
           return temp;
      }
      else{
          Vector<HornRule> rr = rawRules.get(a.getPredicate());

          Vector<Vector<Atom>> expanded = new Vector();
          Vector<Atom> va = new Vector<Atom>();
          if(a.isBinary())
            va.add(new Atom(a.getPredicate(),HornRule.X,HornRule.Y));
          else
             va.add(new Atom(a.getPredicate(),HornRule.X));
          expanded.add(va);

          if(rr==null){
              expandedAtoms.put(a.getPredicate(), expanded);
              Vector<Vector<Atom>> temp = new Vector<Vector<Atom>>();
              Vector<Atom> tempv = new Vector<Atom>();
              tempv.add(a);
              temp.add(tempv);
              return temp;
          }
          Iterator<HornRule> it = rr.iterator();
          inPlay.add(a.getPredicate());
          while(it.hasNext()){
              HornRule rule = it.next();
              Vector<Atom> body = rule.getBody();
              Iterator<Atom> ait = body.iterator();
              Vector<Vector<Atom>> conj = new Vector<Vector<Atom>>();
              while(ait.hasNext()){
                  Atom b = ait.next();
                  if(b.equals(a))
                      break;
                  Vector<Vector<Atom>> holder;
                  if(b.getPredicate().equals(a.getPredicate())||inPlay.contains(b.getPredicate())){
                      holder = new Vector<Vector<Atom>>();
                      Vector<Atom> holderc = new Vector<Atom>();
                      holderc.add(b);
                      holder.add(holderc);
                  }
                  else{
                     holder =  expandAtom(b);
                  }
                  if(conj.isEmpty()){
                      conj = holder;
                      continue;
                  }
                  int size1 = conj.size();
                  int size2 = holder.size();
                  for(int i=0; i<size1; i++){
                      for(int j=0; j<size2; j++){
                          if(!holder.get(j).contains(a))  //no tautology here!
                            conj.get(i).addAll(holder.get(j)); //conj to DNF
                      }
                  }
                  //conjunc
              }
              expanded.addAll(conj);
              //disjunc
          }
          expandedAtoms.put(a.getPredicate(), expanded);
          int diff = a.getFirstArgument()-HornRule.X;
          Vector<Vector<Atom>> temp = new Vector<Vector<Atom>>();
          for(Iterator<Vector<Atom>> i = expanded.iterator();i.hasNext();){
              Vector<Atom> nochangev = i.next();
              Vector<Atom> tempv = new Vector<Atom>();
              for(Iterator<Atom> j = nochangev.iterator(); j.hasNext(); ){
                  Atom nochangea = j.next();
                  Atom tempa;
                  if(nochangea.isBinary())
                      tempa = new Atom(nochangea.getPredicate(),nochangea.getFirstArgument()+diff,nochangea.getSecondArgument()+diff);
                  else
                      tempa =  new Atom(nochangea.getPredicate(),nochangea.getFirstArgument()+diff);
                   tempv.add(tempa);
              }
              temp.add(tempv);
          }
          inPlay.remove(a.getPredicate());
          return temp;
      }
  }
*/
  public void updateView(Atom a, Vector<Vector<Atom>> DNF){
      if(dbName==null)
        dbName = ((DldbStorage)getModel()).getDBName();
      //assume head is always class
      ObjectId aoid = new ObjectId(a.getPredicate());
      String tname = model.getTableName(aoid);
//if(tname.equalsIgnoreCase("graduatestudent_1"))
//return;
      String vname = tname+"_"+ontSeq+"_view";
      StringBuffer viewDef = new StringBuffer("CREATE or REPLACE VIEW ")
                             .append(vname).append(" as ");
      Vector<Atom> disj = null;

      for(Iterator<Vector<Atom>> i =DNF.iterator(); i.hasNext();){
          if(disj!=null)
              viewDef.append(" UNION ALL ");
          disj= i.next();
          StringBuffer select = new StringBuffer();
          StringBuffer from = new StringBuffer(" FROM ");
          StringBuffer where = new StringBuffer();
          Vector tables = new Vector();
          Hashtable variables = new Hashtable();
          int count = 0;
          boolean withdraw = false;
          for(Iterator<Atom> ai =disj.iterator(); ai.hasNext();){
              count++;
              Atom atom = ai.next();
              ObjectId atoid = new ObjectId(atom.getPredicate());
              String atname = model.getTableName(atoid);
              if(atname==null){
                  System.out.println("table name null: "+atom.getPredicate());
                  break;
              }
              String avname = "";
              if(atom.isBinary()){
                  avname = atname + "_p_" + ontSeq + "_view";
                  edu.lehigh.swat.hawk.core.OntProperty prop = this.getProperty(atoid);
                  if((prop.getDomain()!=null&&atom.getFirstArgument() == a.getFirstArgument()&&prop.getDomain().equals(aoid))
                     ||(prop.getRange()!=null&&atom.getSecondArgument() == a.getFirstArgument()&&prop.getRange().equals(aoid)))
                  {
                      withdraw = true;
                      break;
                  }
              }
              else{
                  if(atom.isPrimitive())
                      avname = atname + "_" + ontSeq + "_ext_view";
                  else
                      avname = atname + "_" + ontSeq + "_view";
              }
              if(count>1)
                  from.append(", ");
              if(!tables.contains(avname)){
                  from.append(avname);
                  tables.add(avname);
              }
              else{
                  from.append(avname+" AS "+avname+count);
                  avname = avname+count;
                  tables.add(avname);
              }
              if(variables.size()==0){//write SELECT clause
                  if (atom.isBinary()) {
                      if (atom.getFirstArgument() == a.getFirstArgument())
                          select.append("SELECT " + avname + ".subject, ")
                                  .append(avname + ".source, ").append(ontSeq);
                      else
                          select.append("SELECT " + avname + ".object, ")
                                  .append(avname + ".source, ").append(ontSeq);

                      variables.put(atom.getFirstArgument(), avname + ".subject");
                      variables.put(atom.getSecondArgument(), avname + ".object");

                  } else {
                      if (atom.getFirstArgument() == a.getFirstArgument()){
                          select.append("SELECT " + avname + ".id, ")
                                  .append(avname + ".source, ").append(ontSeq);

                      variables.put(atom.getFirstArgument(), avname + ".id");
                      }
                  }
              }else{//write WHERE clause.
                  if(where.length()==0)
                      where.append(" WHERE ");
                  if (atom.isBinary()) {
                      if (variables.get(atom.getFirstArgument())!=null)
                          where.append(avname + ".subject = ")
                                  .append(variables.get(atom.getFirstArgument())).append(" AND ");
                      else
                          variables.put(atom.getFirstArgument(), avname+".subject");
                      if (variables.get(atom.getSecondArgument())!=null)
                         where.append(avname + ".object = ")
                                 .append(variables.get(atom.getFirstArgument())).append(" AND ");
                      else
                          variables.put(atom.getSecondArgument(), avname+".object");
                  }else{
                      if (variables.get(atom.getFirstArgument())!=null)
                          where.append(avname + ".id = ")
                                  .append(variables.get(atom.getFirstArgument())).append(" AND ");
                      else
                          variables.put(atom.getFirstArgument(), avname+".id");
                  }
              }
          }

          if(from.length()>7&&!withdraw){
              viewDef.append(select);
              viewDef.append(from);
              if (where.length() > 5){
                  where = where.delete(where.length()-4, where.length());
                  viewDef.append(where);
              }
          }
          else
              viewDef.delete(viewDef.length()-10, viewDef.length());
      }
      String qs = viewDef.toString();
//System.out.println("\n"+qs);

      try{
          if (dbName.indexOf("mysql") > 0)
                stmt.execute(qs);
      }catch(SQLException e){
          System.out.println("error when recreate class hierarchy");
          System.out.println(vname+": "+DNF.size());
      //    System.out.println(qs);
          System.out.println("SQLState:" + e.getSQLState());
          System.out.println("Message :" + e.getMessage());
          System.out.println("Vendor  :" + e.getErrorCode());
      }
  }

  public void flushCyclicRules(){
      if(dbName==null)
          dbName = ((DldbStorage)getModel()).getDBName();

	  Set set = memoryOnto.getCyclicRules().entrySet();
      Iterator<Entry> it = set.iterator();
      while(it.hasNext()){
          Entry<String, Vector<Vector<Atom>>> en = it.next();
          String pred = en.getKey();
          Vector<Vector<Atom>> DNF = en.getValue();

            //assume head is always class
            String tname = model.getTableName(new ObjectId(pred));
            String vname = tname+"_"+ontSeq+"_cycle_view";
            StringBuffer viewDef = new StringBuffer("CREATE or REPLACE VIEW ")
                                   .append(vname).append(" as ");
            Vector<Atom> disj = null;

            for(Iterator<Vector<Atom>> i =DNF.iterator(); i.hasNext();){
                if(disj!=null)
                    viewDef.append(" UNION ALL ");
                disj= i.next();
                StringBuffer from = new StringBuffer(" FROM ");
                StringBuffer where = new StringBuffer();
                String lastViewName = null;
                Atom lastAtom = null;
                Vector tables = new Vector();
                int count = 0;
                for(Iterator<Atom> ai =disj.iterator(); ai.hasNext();){
                    count++;
                    Atom atom = ai.next();
                    String atname = model.getTableName(new ObjectId(atom.getPredicate()));
                    if(atname==null){
                        System.out.println("table name null: "+atom.getPredicate());
                        break;
                    }
                    String avname = "";
                    if(atom.isBinary())
                        avname = atname+"_p_"+ontSeq+"_view";
                    else
                        avname = atname+"_"+ontSeq+"_view";
                    if(count>1)
                        from.append(", ");
                    if(!tables.contains(avname)){
                        from.append(avname);
                        tables.add(avname);
                    }
                    else{
                        from.append(avname+" AS "+avname+count);
                        avname = avname+count;
                        tables.add(avname);
                    }
                    if(lastViewName==null){//write SELECT clause
                        if (atom.isBinary()) {
                            if (atom.getFirstArgument() == HornRule.X)
                                viewDef.append("SELECT " + avname + ".subject, ")
                                        .append(avname + ".source, ").append(ontSeq);
                            else
                                viewDef.append("SELECT " + avname + ".object, ")
                                        .append(avname + ".source, ").append(ontSeq);
                        } else {
                            if (atom.getFirstArgument() == HornRule.X)
                                viewDef.append("SELECT " + avname + ".id, ")
                                        .append(avname + ".source, ").append(ontSeq);
                        }
                    }else{//write WHERE clause.
                        if(where.length()==0)
                            where.append(" WHERE ");
                        if (atom.isBinary()&&lastAtom.isBinary()) {
                            if (atom.getFirstArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".subject = ")
                                        .append(lastViewName + ".subject AND ");
                            if (atom.getFirstArgument() == lastAtom.getSecondArgument())
                                where.append(avname + ".subject = ")
                                        .append(lastViewName + ".object AND ");
                            if (atom.getSecondArgument() == lastAtom.getSecondArgument())
                                where.append(avname + ".object = ")
                                        .append(lastViewName + ".object AND ");
                            if (atom.getSecondArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".object = ")
                                        .append(lastViewName + ".subject AND ");
                        }
                        if(atom.isBinary()&&!lastAtom.isBinary()){
                            if (atom.getFirstArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".subject = ")
                                        .append(lastViewName + ".id AND ");
                            if (atom.getSecondArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".object = ")
                                        .append(lastViewName + ".id AND ");
                        }
                        if(!atom.isBinary()&&lastAtom.isBinary()){
                            if (atom.getFirstArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".id = ")
                                        .append(lastViewName + ".subject AND ");
                            if (atom.getFirstArgument() == lastAtom.getSecondArgument())
                                where.append(avname + ".id = ")
                                        .append(lastViewName + ".object AND ");
                        }
                        if(!atom.isBinary()&&!lastAtom.isBinary()){
                            if (atom.getFirstArgument() == lastAtom.getFirstArgument())
                                where.append(avname + ".id = ")
                                        .append(lastViewName + ".id AND ");
                        }
                    }

                    lastViewName = avname;
                    lastAtom = atom;
                }
                if(where.length()>5)
                    where = where.delete(where.length()-4, where.length());
                viewDef.append(from);
                if(where.length()>0)
                    viewDef.append(where);

                if(viewDef.length()<20)
                    continue;

            }
            String qs = viewDef.toString();
            try{
                if (dbName.indexOf("mysql") > 0)
                      stmt.execute(qs);
            }catch(SQLException e){
                System.out.println("error when recreate class hierarchy");
                System.out.println(qs);
                System.out.println("SQLState:" + e.getSQLState());
                System.out.println("Message :" + e.getMessage());
                System.out.println("Vendor  :" + e.getErrorCode());
            }
      }

  }


  /**
   * Get the priorVersion ontologies which are backwardCompatibleWith
   */
  public DocId[] getCompatiblePriorOnts(){
    compatibleOntos = new Vector();
    DocId[] dIds = memoryOnto.getCompatiblePriorOnts();
    if (dIds==null)
      return null;
    int len = dIds.length;
    for(int i=0;i<len;i++){
      DocId did = dIds[i];
      compatibleOntos.add(model.getDocument(did.getId()));
    }
    return dIds;
  }

//  protected int ontSeq;
//  protected edu.lehigh.swat.hawk.storage.dlmemory.Ontology memoryOnto;
  private Vector compatibleOntos;
//  private String dbName;

}
