/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage.ontper.simpledb;

import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.storage.simpledb.Document;
import java.sql.*;
import java.util.*;

/**
 * The ontology that supports versioning.
 * @author Z. Pan
 * @version 1.0
 */


public class Ontology extends edu.lehigh.swat.hawk.storage.simpledb.Ontology{

  /**
   * Constructor
   *
   */
  public Ontology(edu.lehigh.swat.hawk.storage.simplememory.Ontology mOnto){
      super(mOnto);
  }


  /**
   * add a class to this ontology
   */
  public void addOntClass(edu.lehigh.swat.hawk.core.OntClass c){
    memoryOnto.addOntClass(c);

    if(compatibleOntos==null)
      this.getCompatiblePriorOnts();

    if(c.getID().getLocalName()==null||c.getID().getLocalName()=="")
      return;
    String tableName = model.getTableName(c.getID());
    String className = c.getID().getLocalName();
    int currentSeqNum = this.ontSeq;

    String qs = "CREATE TABLE "+tableName
    +" (\nID NUMBER,\nSOURCE NUMBER,ONTO NUMBER,\nPRIMARY KEY(ID,SOURCE)\n)";

//    log.println(qs);
    try
    {
      stmt.executeUpdate(qs);
    }
     catch(SQLException e)
              {
              //   log.println("error when store class");
                System.out.println("error when store class");
                System.out.println("SQLState:"+e.getSQLState());
                System.out.println("Message :"+e.getMessage());
                System.out.println("Vendor  :"+e.getErrorCode());

              }
/*
    Stack des = (Stack)this.getDescendants().clone();
    int viewSeqNum = -1;
    int lastSeqNum = -1;
    Ontology ont;
    while(!des.empty()){
      lastSeqNum = viewSeqNum;
      Document doc = (Document)des.pop();
      if(doc instanceof Ontology){
        ont = (Ontology)doc;
        viewSeqNum = ont.getOntSeq();
      }
      else
        continue;
*/
      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
//      if(viewSeqNum == currentSeqNum){

        qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
            +" WHERE ONTO="+currentSeqNum;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(className))
            qs2+=" UNION SELECT * FROM "+className+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }
 /*     }
      else{
        qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName
            +"_"+String.valueOf(lastSeqNum)+"_view"
            +" UNION SELECT * FROM "+tableName+" WHERE ONTO="+viewSeqNum;
        edu.lehigh.swat.hawk.core.OntClass oc = ont.createClass();
        oc.setID(c.getID());
        ont.addImportedClass(c.getID(),oc);
      }
  */
      String qs3 = "";
      try{
        qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
      }
      catch(SQLException e){
              //  log.println("error when store class, create view");

             System.out.println(qs2);
              System.out.println("error when store class, create view");
                System.out.println("SQLState:"+e.getSQLState());
                System.out.println("Message :"+e.getMessage());
                System.out.println("Vendor  :"+e.getErrorCode());

      }
    //}
  }


  /**
   * add a property to this ontology
   */
  public void addProperty(edu.lehigh.swat.hawk.core.OntProperty prop){
    memoryOnto.addProperty(prop);

    String tableName = model.getTableName(prop.getID());
    String propName = prop.getID().getLocalName();
    int currentSeqNum = this.ontSeq;
    String qs = "";
    String pinfo = "INSERT INTO propertytypes VALUES('";

    if(prop.isDatatype()!=null&&prop.isDatatype().booleanValue())
    {
      qs = "CREATE TABLE "+tableName
    +" (\nSUBJECT NUMBER,\nOBJECT VARCHAR (100),\nSOURCE NUMBER,\nONTO NUMBER,\nPRIMARY KEY(SUBJECT,OBJECT,SOURCE)\n)";

      pinfo += tableName+"', 'datatype')";
    }
    else
    {
      qs = "CREATE TABLE "+tableName
    +" (\nSUBJECT NUMBER,\nOBJECT NUMBER,\nSOURCE NUMBER,\nONTO NUMBER,\nPRIMARY KEY(SUBJECT,OBJECT,SOURCE)\n)";

      pinfo += tableName+"', 'object')";
    }
   // log.println(qs);

    try{
      stmt.executeUpdate(qs);
      stmt.executeUpdate(pinfo);
    }
    catch(SQLException e){
                //log.println("error when store property");
      System.out.println("error when store property");
      System.out.println("SQLState:"+e.getSQLState());
      System.out.println("Message :"+e.getMessage());
      System.out.println("Vendor  :"+e.getErrorCode());
    }

/*    Stack des = (Stack)this.getDescendants().clone();
    int viewSeqNum = -1;
    int lastSeqNum = -1;
    Ontology ont;
    while(!des.empty()){
      lastSeqNum = viewSeqNum;
      Document doc = (Document)des.pop();
      if(doc instanceof Ontology){
        ont = (Ontology)doc;
        viewSeqNum = ont.getOntSeq();
      }
      else
        continue;
*/
      String qs2 = "";
      String viewName = tableName+"_"+String.valueOf(ontSeq)+"_view";
  //    if(viewSeqNum == currentSeqNum){

        qs2 = "CREATE VIEW "+viewName+" AS\n SELECT * FROM "+tableName
            +" WHERE ONTO="+currentSeqNum;

        int size = compatibleOntos.size();
        for(int i=0;i<size;i++){
          Ontology cmpOnt = (Ontology)compatibleOntos.get(i);
          if(cmpOnt.hasClass(propName))
            qs2+=" UNION SELECT * FROM "+propName+"_"+cmpOnt.getOntSeq()
                +" WHERE ONTO="+cmpOnt.getOntSeq();
        }
/*      }
      else{
        qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+tableName
            +"_"+String.valueOf(lastSeqNum)+"_view"
            +" UNION SELECT * FROM "+tableName+" WHERE ONTO="+viewSeqNum;
        edu.lehigh.swat.hawk.core.OntProperty oc = ont.createProperty();
        oc.setID(prop.getID());
        ont.addImportedProperty(prop.getID(),oc);
      }
 */
      String qs3 = "";
      try{
        qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
        stmt.executeUpdate(qs2);
        stmt.executeUpdate(qs3);
      }
      catch(SQLException e){
              //  log.println("error when store class, create view");
        System.out.println(qs2);
        System.out.println("error when store class, create view");
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
// }

  }


  /**
   * Get the priorVersion ontologies which are backwardCompatibleWith
   */
  public DocId[] getCompatiblePriorOnts(){
    compatibleOntos = new Vector();
    DocId[] dIds = memoryOnto.getCompatiblePriorOnts();
    if (dIds==null)
      return null;
    int len = dIds.length;
    for(int i=0;i<len;i++){
      DocId did = dIds[i];
      compatibleOntos.add(model.getDocument(did.getId()));
    }
    return dIds;
  }


  /**
   * Flush the axioms into database.
   */
  public void flush(){
    flushImports();
    flushSubs();
    flushEquivals();
  }

  protected void flushSubs(){
    //deal with subClass
    edu.lehigh.swat.hawk.core.OntClass[] classes = this.getAllPlusImportedClasses();
    int cNum = classes.length;

    for(int i=0;i<cNum;i++){
      edu.lehigh.swat.hawk.core.OntClass cls = classes[i];
      if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
        continue;
      if(importedClass(cls.getID())&&!assertedClass(cls.getID()))
         continue;

     ObjectId[] sid = cls.getDirectSubClasses();
      String className = model.getTableName(cls.getID());
      int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      int sn =0;
      if(sid!=null)
        sn = sid.length;
      if(sn<=0)
        continue;
      String vName = className
          +"_"+String.valueOf(ontSeq)+"_view";
      String dv = "DROP TABLE "+vName;
      StringBuffer cvb;

      String def = model.getViewDefinition(vName);
      cvb = new StringBuffer(def);
/*
      if(oriSeq!=ontSeq){
        int beg = def.indexOf("FROM ")+5;
        int end = def.indexOf(' ',beg+1);
        String fvName = def.substring(beg,end);
  //      String fvName1= fvName.substring(0,12);
        String vdef = model.getViewDefinition(fvName);
        Vector v = this.viewDefToTabNames(vdef);
        int len = v.size();
        for(int j=1;j<len;j++){
          String tname = (String)v.get(j);
          cvb.append(" UNION SELECT * FROM "+tname).append(" WHERE ONTO="+ontSeq);
        }
      }
*/
      for(int j=0;j<sn;j++){
        cvb.append(" UNION ALL SELECT * FROM ");
        String tName = model.getTableName(sid[j]);
        int sOriSeq = model.getOntSeq(sid[j].getNameSpace());
        String avName = tName+"_"+ontSeq+"_view";
        String vdef = model.getViewDefinition(avName);
        if(vdef!=null){
          int ind = vdef.indexOf(" FROM");
          vdef = vdef.substring(ind+5);
        }
        if(vdef!=null&&vdef.indexOf(" "+className)>0){
          int i1 = vdef.indexOf(" "+className);
          int i2 = vdef.indexOf(' ',i1+1);
          if(i2<=0)
            i2 = vdef.length();
          int i0 = i1-20;
          StringBuffer sb = new StringBuffer(vdef);
          sb.delete(i0,i2);
          cvb.append(sb);
        }
        else
          cvb.append(tName).append("_"+ontSeq).append("_view");
      }
      try{
        String cv = cvb.toString();
        stmt.execute(dv);
        stmt.execute(cv);
        String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
             "WHERE view='"+vName+"';";
        stmt.execute(qs3);

      }
      catch(SQLException e){
        System.out.println("error when recreate class hierarchy");
        System.out.println(cvb.toString());
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
    }

   // deal with subProperty
   edu.lehigh.swat.hawk.core.OntProperty[] Properties = this.getAllPlusImportedProperties();
   int pNum = Properties.length;

   for(int i=0;i<pNum;i++){
     edu.lehigh.swat.hawk.core.OntProperty cls = Properties[i];
     if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
       continue;
     if(importedProperty(cls.getID())&&!assertedProperty(cls.getID()))
         continue;

     ObjectId[] sid = cls.getDirectSubProperties();
     String propertyName = model.getTableName(cls.getID());
     int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
     if(sid==null)
       continue;
     int sn = sid.length;
     if(sn<=0)
       continue;
     String vName = propertyName
         +"_"+String.valueOf(ontSeq)+"_view";
     String dv = "DROP TABLE "+vName;
     StringBuffer cvb;

     String def = model.getViewDefinition(vName);
     cvb = new StringBuffer(def);

     for(int j=0;j<sn;j++){
       cvb.append(" UNION ALL SELECT * FROM ");
       String tName = model.getTableName(sid[j]);
       int sOriSeq = model.getOntSeq(sid[j].getNameSpace());
       String avName = tName+"_"+ontSeq+"_view";
       String vdef = model.getViewDefinition(avName);
       if(vdef!=null){
         int ind = vdef.indexOf(" FROM");
         vdef = vdef.substring(ind+5);
       }
       if(vdef!=null&&vdef.indexOf(" "+propertyName)>0){
         int i1 = vdef.indexOf(" "+propertyName);
         int i2 = vdef.indexOf(' ',i1+1);
         if(i2<=0)
           i2 = vdef.length();
         int i0 = i1-20;
         StringBuffer sb = new StringBuffer(vdef);
         sb.delete(i0,i2);
         cvb.append(sb);
       }
       else
         cvb.append(tName).append("_"+ontSeq).append("_view");
     }
     try{
       String cv = cvb.toString();
       stmt.execute(dv);
       stmt.execute(cv);
       String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
            "WHERE view='"+vName+"';";
       stmt.execute(qs3);

     }
     catch(SQLException e){
       System.out.println("error when recreate property hierarchy");
       System.out.println(cvb.toString());
       System.out.println("SQLState:"+e.getSQLState());
       System.out.println("Message :"+e.getMessage());
       System.out.println("Vendor  :"+e.getErrorCode());
     }
   }
  }

  protected void flushEquivals(){
    //deal with equivalentClass
    edu.lehigh.swat.hawk.core.OntClass[] classes = this.getAllPlusImportedClasses();
    int cNum = classes.length;
    for(int i=0;i<cNum;i++){
      edu.lehigh.swat.hawk.core.OntClass cls = classes[i];
      if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
        continue;
      if(importedClass(cls.getID())&&!assertedClass(cls.getID()))
         continue;

      ObjectId[] eid = cls.getEquivalentClasses();
      String className = model.getTableName(cls.getID());
      int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      if(eid==null)
        continue;
      int sn = eid.length;
      if(sn<=0)
        continue;
      String vName = className
          +"_"+String.valueOf(ontSeq)+"_view";
      String dv = "DROP TABLE "+vName;
      StringBuffer cvb;
      String start = model.getViewDefinition(vName);
      cvb = new StringBuffer(start);

      for(int j=0;j<sn;j++){
        cvb.append(" UNION ALL SELECT * FROM ");
        String tName = model.getTableName(eid[j]);
        int sOriSeq = model.getOntSeq(eid[j].getNameSpace());
        String avName = tName+"_"+ontSeq+"_view";
        String vdef = model.getViewDefinition(avName);
        if(vdef!=null){
          int ind = vdef.indexOf(" FROM");
          vdef = vdef.substring(ind+5);
        }
        cvb.append(vdef);
      }
      try{
        String cv = cvb.toString();
        stmt.execute(dv);
        stmt.execute(cv);
        String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
            "WHERE view='"+vName+"';";
        stmt.execute(qs3);

      }
      catch(SQLException e){
        System.out.println("error when recreate class hierarchy");
        System.out.println(cvb.toString());
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
    }

    //deal with equivalentProperty
    edu.lehigh.swat.hawk.core.OntProperty[] Properties = this.getAllPlusImportedProperties();
    int pNum = Properties.length;
    for(int i=0;i<pNum;i++){
      edu.lehigh.swat.hawk.core.OntProperty cls = Properties[i];
      if(cls.getID().getLocalName()==null||cls.getID().getLocalName()=="")
        continue;
      if(importedProperty(cls.getID())&&!assertedProperty(cls.getID()))
         continue;

     ObjectId[] eid = cls.getEquivalentProperties();
      String PropertyName = model.getTableName(cls.getID());
      int oriSeq = model.getOntSeq(cls.getID().getNameSpace());
      if(eid==null)
        continue;
      int sn = eid.length;
      if(sn<=0)
        continue;
      String vName = PropertyName
          +"_"+String.valueOf(ontSeq)+"_view";
      String dv = "DROP TABLE "+vName;
      StringBuffer cvb;
      String start = model.getViewDefinition(vName);
      cvb = new StringBuffer(start);

      for(int j=0;j<sn;j++){
        cvb.append(" UNION ALL SELECT * FROM ");
        String tName = model.getTableName(eid[j]);
        int sOriSeq = model.getOntSeq(eid[j].getNameSpace());
        String avName = tName+"_"+ontSeq+"_view";
        String vdef = model.getViewDefinition(avName);
        if(vdef!=null){
          int ind = vdef.indexOf(" FROM");
          vdef = vdef.substring(ind+5);
        }
        cvb.append(vdef);
      }
      try{
        String cv = cvb.toString();
        stmt.execute(dv);
        stmt.execute(cv);
        String qs3 = "UPDATE view_definition SET definition='"+cv+"'"+
            "WHERE view='"+vName+"';";
        stmt.execute(qs3);

      }
      catch(SQLException e){
        System.out.println("error when recreate Property hierarchy");
        System.out.println(cvb.toString());
        System.out.println("SQLState:"+e.getSQLState());
        System.out.println("Message :"+e.getMessage());
        System.out.println("Vendor  :"+e.getErrorCode());
      }
    }
  }

  private void flushImports(){
    DocId[] dids = this.getImports();
    if(dids==null)
      return;
    int len = dids.length;
    for(int i=0;i<len;i++){
      DocId did = dids[i];
      Document doc = (Document)model.getDocument(did.getId());
      if(!(doc instanceof Ontology))
        continue;
      Ontology ionto = (Ontology)doc;
      int iseq = model.getOntSeq(did.getId());
      edu.lehigh.swat.hawk.core.OntClass[] iclss = ionto.getAllPlusImportedClasses();
      int clen = iclss.length;
      for(int j=0;j<clen;j++){
        edu.lehigh.swat.hawk.core.OntClass icls = iclss[j];
        ObjectId cid = icls.getID();
        String tableName = model.getTableName(cid);
        String viewName = tableName+"_"+ontSeq+"_view";
        String ivName = tableName+"_"+iseq+"_view";
        String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+ivName
            +" UNION ALL SELECT * FROM "+tableName+" WHERE ONTO="+ontSeq;
        StringBuffer cvb;
        cvb = new StringBuffer(qs2);
        String vdef = model.getViewDefinition(ivName);
        Vector v = this.viewDefToTabNames(vdef);
        int len2 = v.size();
        for(int k=1;k<len2;k++){
          String tname = (String)v.get(k);
          cvb.append(" UNION ALL SELECT * FROM "+tname).append(" WHERE ONTO="+ontSeq);
        }

        qs2 = cvb.toString();
        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.executeUpdate(qs2);
          stmt.executeUpdate(qs3);
        }
        catch(SQLException e){
        //  log.println("error when store class, create view");
          System.out.println(qs2);
          System.out.println("error when store class, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());

        }
      }
      edu.lehigh.swat.hawk.core.OntProperty[] iprops = ionto.getAllPlusImportedProperties();
      int plen = iprops.length;
      for(int j=0;j<plen;j++){
        edu.lehigh.swat.hawk.core.OntProperty iprop = iprops[j];
        ObjectId pid = iprop.getID();
        String tableName = model.getTableName(pid);
        String viewName = tableName+"_"+ontSeq+"_view";
        String ivName = tableName+"_"+iseq+"_view";
        String qs2 = "CREATE VIEW "
            +viewName+" AS\n SELECT * FROM "+ivName
            +" UNION ALL SELECT * FROM "+tableName+" WHERE ONTO="+ontSeq;
        StringBuffer cvb;
        cvb = new StringBuffer(qs2);
        String vdef = model.getViewDefinition(ivName);
        Vector v = this.viewDefToTabNames(vdef);
        int len2 = v.size();
        for(int k=1;k<len2;k++){
          String tname = (String)v.get(k);
          cvb.append(" UNION ALL SELECT * FROM "+tname).append(" WHERE ONTO="+ontSeq);
        }

        qs2 = cvb.toString();
        try{
          String qs3 = "INSERT INTO view_definition VALUES ('"+viewName+"', '"+qs2+"')";
          stmt.executeUpdate(qs2);
          stmt.executeUpdate(qs3);
        }
        catch(SQLException e){
        //  log.println("error when store Property, create view");
          System.out.println(qs2);
          System.out.println("error when store Property, create view");
          System.out.println("SQLState:"+e.getSQLState());
          System.out.println("Message :"+e.getMessage());
          System.out.println("Vendor  :"+e.getErrorCode());

        }
      }

    }
  }



  /**
   * Get the imported class.
   */
//  public edu.lehigh.swat.hawk.core.OntClass getImportedClass(ObjectId id){
//    return memoryOnto.getImportedClass(id);
//  }

  /**
   * To see if ontology has imported the property.
   */
//  public edu.lehigh.swat.hawk.core.OntProperty getImportedProperty(ObjectId id){
//    return memoryOnto.getImportedProperty(id);
//  }

//  private int ontSeq;
//  private edu.lehigh.swat.hawk.storage.simplememory.Ontology memoryOnto;
  private Vector compatibleOntos;

}
