/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.storage.ontper.simpledb;

import java.sql.*;
import java.util.*;
import java.io.*;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.storage.Result;
import edu.lehigh.swat.hawk.storage.simpledb.*;

/**
 * Database storage model that supports perspectives
 * @author Z. Pan
 * @version 1.0
 */

public class PerDbStorage extends edu.lehigh.swat.hawk.storage.simpledb.DatabaseStorage{
/**
 * Constructor.
 * @param DBName
 */
 public PerDbStorage(String DBName) {
  super(DBName);
 }

 /**
 * Create an Ontology object.
 */
 public edu.lehigh.swat.hawk.core.Ontology createOntology(){
   edu.lehigh.swat.hawk.storage.simplememory.Ontology mOnto =
      new edu.lehigh.swat.hawk.storage.simplememory.Ontology();
   Ontology onto = new Ontology(mOnto);
   onto.setDocSeq(++sourceSeqNum);
   onto.setOntSeq(++ontSeqNum);
   onto.setSQLStatement(stmt);
   onto.setModel(this);
   return onto;
 }

 /**
  * Execute query and return results.
  */
 public edu.lehigh.swat.hawk.storage.ResultSet issueQuery(edu.lehigh.swat.hawk.storage.Query qry){
   edu.lehigh.swat.hawk.storage.ResultSet rset;
   java.sql.ResultSet rs;

   Query query = (Query)qry;
   DocId persp = query.getPerspective();
   String nameSpace = persp.getId().concat("#");
   int perspSeq = this.getOntSeq(nameSpace);
   //ObjectId oid = new ObjectId("");
   if(propertyTypes==null)
     getPropertyTypes();

   int i,j,ptype=0;
   Vector a = query.getAtoms();
   int l = a.size();
   String lastarg1="",lastarg2="",lastpre="",catfor="",catname="";
   StringBuffer colName = new StringBuffer("SELECT ");
   StringBuffer tableName = new StringBuffer("FROM ");
   StringBuffer condition = new StringBuffer("WHERE ");
   int hasname=0;
   int colnum = 0;
   Vector vcol = new Vector();
   vcol.clear();

   Vector tables = new Vector();
   tables.clear();

 //  Vector columns = new Vector();//new for alias
 //  columns.clear(); //--
   boolean same_colname = false;

     Hashtable classes = new Hashtable();
     Hashtable properties = new Hashtable();

   for(i=0;i<l;i++)
   {
     ptype=0;
     Atom am = (Atom) a.get(i);
     String sp = am.toString();
     System.out.println(sp);

     String amp = am.getPredicate();
     String[] ama = am.getArguments();
     if(amp.startsWith("@every"))
     ptype=1;
     if(amp.startsWith("@string"))
     ptype=2;

     String tn;

     switch(ptype)
     {
     case 1:
             ObjectId objid;
             if(ama[0].indexOf('#')>=0)
               objid = new ObjectId(ama[0]);
             else
               objid = new ObjectId(nameSpace+ama[0]);

             tn = getTableName(objid);
             tn = tn+"_"+perspSeq;
             tableName.append(tn).append("_view, ");
             tableName.append("url_index AS ui"+i+", ");
             colName.append("ui"+i+".url, ");
             condition.append(tn+"_view.id = ui"+i+".id AND ");
             vcol.add(ama[1]);

             classes.put(ama[1],tn+"_view.ID");

     break;
     case 2:

             //colName.append("url_index.url, url_index.id, ");
             if(properties.get(ama[0])!=null)
             {
               String fullname = (String)properties.get(ama[0]);
               int dot = fullname.indexOf('.');
               String tname = fullname.substring(0,dot-5).toLowerCase();
               String cname = fullname.substring(dot);
               String type = "";
              try
               {

  /*               rs = con.getMetaData().getColumns("","",tname,cname);
                 if(rs.next())
                   type = rs.getString("TYPE_NAME");
   */
                type = (String)propertyTypes.get(tname);
               }
               catch(Exception e)
               {
                System.err.println(e.getMessage());
               }


               if(type.equalsIgnoreCase("object"))
               {
                 tableName.append("url_index AS ui"+i+", ");
                 condition.append("ui"+i+".url");
                 condition.append(" LIKE '").append(ama[1]).append("' AND ");
                 condition.append(properties.get(ama[0]));
                 condition.append("=").append("ui"+i+".id AND ");
               }
               else
               {
                 condition.append(properties.get(ama[0]));
                 condition.append(" LIKE '").append(ama[1]).append("' AND ");
               }
             }
     break;
     default:
             ObjectId oid;
             if(amp.indexOf('#')>=0)
               oid = new ObjectId(amp);
             else
               oid = new ObjectId(nameSpace+amp);
             tn = getTableName(oid).toLowerCase();
             tn = tn+"_"+perspSeq;
             if(!tables.contains(tn))
             {
               tableName.append(tn).append("_view, ");
               tables.add(tn);
             }

             if(ama[1].startsWith("?"))
             {
               if(classes.get(ama[1])!=null)
               {
                   String select_column_name = tn+"_view.subject";
                   tableName.append("url_index AS ui"+i+", ");
                   colName.append("ui"+i+".url, ");
                   condition.append(select_column_name).append(" = ");
                   condition.append("ui"+i+".id AND ");
                   vcol.add(ama[0]);

                   condition.append(classes.get(ama[1])).append("=");
                   condition.append(tn).append("_view.object AND ");
                   if(ama[0].startsWith("?"))
                   {
                     properties.put(ama[0], select_column_name);
                   }
                //   else{
                //     condition.append(select_column_name).append("=").append(ama[0]);
                //   }
                 }
                 else
                 {
                   String select_column_name = tn+"_view.object";
                   String type = (String)propertyTypes.get(tn);
                   if(type.equalsIgnoreCase("datatype"))
                     colName.append(select_column_name).append(", ");
                   else{
                     tableName.append("url_index AS ui"+i+", ");
                     colName.append("ui"+i+".url, ");
                     condition.append(select_column_name+" = ui"+i+".id AND ");
                   }
                   properties.put(ama[1], select_column_name);
                   vcol.add(ama[1]);
                 }

               }

              if(properties.get(ama[0])!=null&&classes.get(ama[0])==null)
              {
                    condition.append(properties.get(ama[0])).append("=");
                    condition.append(tn).append("_view.subject ").append(" AND ");
              }

             if(classes.get(ama[0])!=null)
               {
                 condition.append(classes.get(ama[0])).append("=");
                 condition.append(tn).append("_view.subject AND ");

               }

               if(!ama[0].startsWith("?"))
               {
                 tableName.append("url_index AS uis"+i+", ");
                 condition.append("uis"+i+".url='").append(ama[0]).append("' AND ");
                 condition.append(tn).append("_view.subject=uis"+i+".id AND ");

               }


               if(!ama[1].startsWith("?"))//is argument a variable?
               {
                 tableName.append("url_index AS uio"+i+", ");
                 condition.append("uio"+i+".url='").append(ama[1]).append("' AND ");
                 condition.append(tn).append("_view.object=uio"+i+".id AND ");
               }

     }//end switch

  }//end for
 int len = colName.length();
   colName.delete(len-2,len);
   colName.append("\n");

   len = tableName.length();
   tableName.delete(len-2,len);
   tableName.append("\n");

   len = condition.length();
   condition.delete(len-4,len);
   condition.append("\n");

   String colNames = colName.toString();
   String tableNames = tableName.toString();
   String conditions = condition.toString();

   if(conditions.length()>6)
   System.out.println(colNames+tableNames+conditions);
   else
   System.out.println(colNames+tableNames);

   colnum = vcol.size();
   String[] varnames = new String[vcol.size()];
   for(i=0;i<colnum;i++)
   varnames[i] = (String) vcol.elementAt(i);

   rset = new edu.lehigh.swat.hawk.storage.ResultSet();


   try
   {
//     rs.close();  //zpan
   long t0 = System.currentTimeMillis();// test
   if(conditions.length()>6)
   rs = stmt.executeQuery(colNames+tableNames+conditions);
   else
   rs = stmt.executeQuery(colNames+tableNames);
   //test
   long t1 = System.currentTimeMillis();
   long t = t1-t0;
   System.out.println("\n\ntime in SQL query: "+t+"ms.");
   //end test

   while(rs.next())
   {
     String[] data = new String[colnum];
     for(i=0;i<colnum;i++)
     {
       data[i] = rs.getString(i+1);

     }

     rset.addResult(new Result(data));
   }

//    rset.setSqlResult(rs);
 //  rs.close();
   }

    catch(SQLException e)
               {	System.out.println("error when do query");
                       System.out.println(e.getMessage());
               }

  return rset;

 }


}