/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.storage.simpledb;

/**
 * The interface of kif-like format query.
 * @author Z. Pan
 * @version 1.0
 */
import java.util.Map;
import java.util.Vector;

import edu.lehigh.swat.hawk.core.DocId;


public class SparqlQuery extends edu.lehigh.swat.hawk.storage.Query{
  Vector atoms;
  DocId perspective;
  StringBuffer sqlBuff;
  String[] headers;
  Map tables;
  private String origSparql;
  /**
   * Constructor
   */
  public SparqlQuery() {
    atoms = new Vector();
    sqlBuff = new StringBuffer();
    origSparql = "";
  }
  public SparqlQuery(String sparqlQry){
	  atoms = new Vector();
	  sqlBuff = new StringBuffer();
	  origSparql = sparqlQry;
  }
  public void setOrigSparql(String sparqlQry){
	  origSparql = sparqlQry;
  }
  public String getOrigSparql(){
	  return origSparql;
  }
  public String[] getHeaders(){
	  return headers;
  }
  public void setHeaders(String[] arrayHeaders){
	  headers = new String[arrayHeaders.length];
	  for(int i = 0; i < arrayHeaders.length; i++)
		  headers[i] = arrayHeaders[i];
  }
  public void addToSql(String str)
  {
	  sqlBuff.append(str);
  }
  public String getSql()
  {
	  return sqlBuff.toString();
  }

  public Map getDBTables(){
      return tables;
  }

  public void setDBTables(Map tb){
      tables = tb;
  }
  /** Adds an additional atom as a conjunct to the existing sentence
  where the input is the atom to be added. */
  public void addConjunct(Atom atom) {
    atoms.add(atom);
  }

  /** Returns the vector of atoms that are conjuncted together
  in the sentence. */
  public Vector getAtoms() {
    return atoms;
  }

  /**
   * Set the perspective ontology's id.
   */
  public void setPerspective(DocId pid){
    perspective = pid;
  }

  /**
   * Get the id of the perspective ontology.
   */
  public DocId getPerspective(){
    return perspective;
  }

  /**
   * Parse a string to query.
   * @param s
   * @return
   */
  public static SparqlQuery StringToQuery(String s){
	  SparqlQuery sQuery = null;
	  //can't do translation here, because need a connection to the database storage to be able to complete
	  //the translation from SPARQL to sql

	  return sQuery;
  }
 /* public static Query StringToQuery(String s){
    try{
      LineNumberReader lr = new LineNumberReader(new StringReader(s));
      Query query = new Query();
      String line;
      while((line=lr.readLine())!=null){
        if(line.startsWith("[")){
          line = line.substring(1,line.length()-1);
          DocId did = new DocId(line);
          query.setPerspective(did);
          continue;
        }
        int end = line.lastIndexOf(')');
        line = line.substring(1,end);
        String[] args = line.split(" ");
        if(args.length!=3){
          System.out.println("syntax error at "+lr.getLineNumber());
          return null;
        }
        Atom atom = new Atom(args[0],args[1],args[2]);
        query.addConjunct(atom);
      }
      return query;
    }
    catch(Exception e){
      e.printStackTrace();
    }
    return null;
  }*/

  public String toString(){
    return sqlBuff.toString();
  }
}

