/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.storage.simplememory;

import edu.lehigh.swat.hawk.core.ObjectId;
import java.util.*;

/**
 * A simple implementation of core.OntObject in memory.
 * @author Z. Pan
 * @version 1.0
 */

public class OntObject implements edu.lehigh.swat.hawk.core.OntObject, java.io.Serializable, java.lang.Cloneable{

  /**
   * Constructor
   */
  public OntObject() {
    id = null;
    ontology = null;
    description = new Vector();
    label = null;

  }

  /**
   * get the uri of this object
   */
  public ObjectId getID(){
    return id;
  }

  /**
   * set the uri of this object
   */
  public void setID(ObjectId oid){
    id = oid;
  }


  /**
   * set the ontology that this object belongs to
   */
  public void setOntology(edu.lehigh.swat.hawk.core.Ontology o){
    ontology = o;
    source = o;
  }

  /**
   * get the ontology that this object belongs to
   */
  public edu.lehigh.swat.hawk.core.Ontology getOntology(){
    return ontology;
  }

  /**
   * Set the source document.
   */
  public void setSource(edu.lehigh.swat.hawk.core.Document d){
     source = d;
  }

  /**
   * Get the source document.
   */
  public edu.lehigh.swat.hawk.core.Document getSource(){
    return source;
  }


  /**
   * Get the description, comment, etc.
   */
  public String getDescription(){
    if(description.size()==0)
      return null;
    else
      return (String)description.elementAt(0);
  }

  /**
   * Get all the descriptions.
   */
  public Iterator getAllDescriptions(){
    return description.iterator();
  }


  /**
   * Set the description, comment, etc.
   */
  public void addDescription(String des){
    description.add(des);
  }

  /**
   * Delete a description.
   */
  public void deleteDescription(String des){
    description.remove(des);
  }


  /**
   * Get the label.
   */
  public String getLabel(){
    return label;
  }

  /**
   * Set the label.
   */
  public void setLabel(String l){
    label = l;
  }

  public Object clone() throws CloneNotSupportedException{
      return super.clone();
  }

  private ObjectId id;
  private edu.lehigh.swat.hawk.core.Ontology ontology;
  private edu.lehigh.swat.hawk.core.Document source;
  private String label;
  private Vector description;
}
