/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.storage.simplememory;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.core.DatatypeValue;
/**
 * A simple implementation of core.PropertyRestriction in memory.
 * @author Z. Pan
 * @version 1.0
 */

public class PropertyRestriction extends OntClass
    implements edu.lehigh.swat.hawk.core.PropertyRestriction{

  /**
   * Constructor
   */
  public PropertyRestriction() {
    minCardinality = 0;
    maxCardinality = this.INFINITY;
    onProperty = null;
    allValuesFrom = null;
    someValuesFrom = null;
    hasValue = null;
  }

  /**
   * Get the property restricted on.
   */
  public ObjectId getOnProperty(){
    return onProperty;
  }

  /**
   * Set the property restricted on.
   */
  public void setOnProperty(ObjectId p){
    onProperty = p;
  }

  /**
   * Get the specified restriction class of 'allValuesFrom'.
   */
  public ObjectId getAllValuesFrom(){
    return allValuesFrom;
  }

  /**
   * Set the specified restriction class of 'allValuesFrom'.
   */
  public void setAllValuesFrom(ObjectId c){
    allValuesFrom = c;
  }

  /**
   * Get the specified restriction class of 'someValuesFrom'.
   */
  public ObjectId getSomeValuesFrom(){
    return someValuesFrom;
  }

  /**
   * Set the specified restriction class of 'someValuesFrom'.
   */
  public void setSomeValuesFrom(ObjectId c){
    someValuesFrom = c;
  }


  /**
   * Get the specified number of 'minCardinality'.
   */
  public int getMinCardinality(){
    return minCardinality;
  }

  /**
   * Set the specified number of 'minCardinality'.
   */
  public void setMinCardinality(int n){
    minCardinality = n;
  }

  /**
   * Get the specified number of 'maxCardinality'.
   */
  public int getMaxCardinality(){
    return maxCardinality;
  }

  /**
   * Set the specified number of 'maxCardinality'.
   */
  public void setMaxCardinality(int n){
    maxCardinality = n;
  }

  /**
   * Get the specified value of 'hasValue'.
   */
  public ObjectId getHasValue(){
    return hasValue;
  }

  /**
   * Set the specified value of 'hasValue'.
   */
  public void setHasValue(ObjectId i){
    hasValue = i;
  }


  private ObjectId onProperty, allValuesFrom, someValuesFrom, hasValue;
  private int minCardinality, maxCardinality;

}
